322. Coin Change选取最少的硬币凑整-背包问题变形

[抄题]:

You are given coins of different denominations and a total amount of money amount. Write a function to compute the fewest number of coins that you need to make up that amount. If that amount of money cannot be made up by any combination of the coins, return -1.

Example 1:

Input: coins = [1, 2, 5], amount = 11
Output: 3 
Explanation: 11 = 5 + 5 + 1

Example 2:

Input: coins = [2], amount = 3
Output: -1

 [暴力解法]:

时间分析:

空间分析:

 [优化后]:

时间分析:

空间分析:

[奇葩输出条件]:

[奇葩corner case]:

dp数组运行了之后才有正常值,所以需要用arrays.fill初始化为奇葩值

[思维问题]:

[英文数据结构或算法,为什么不用别的数据结构或算法]:

Math.min(dp[目标值], dp[目标值 - 当前值] + 1);

[一句话思路]:

[输入量]:空: 正常情况:特大:特小:程序里处理到的特殊情况:异常情况(不合法不合理的输入):

[画图]:

[一刷]:

[二刷]:

[三刷]:

[四刷]:

[五刷]:

  [五分钟肉眼debug的结果]:

[总结]:

记得初始化

[复杂度]:Time complexity: O(n2) Space complexity: O(n)

[算法思想:迭代/递归/分治/贪心]:

[关键模板化代码]:

[其他解法]:

 

class Solution {
    public int coinChange(int[] coins, int amount) {
        //corner case
      if (coins == null || coins.length <= 0 || amount <= 0) return -1;
      
      //initialization: dp[] and fill, and the first num
      int[] dp = new int[amount + 1];
      Arrays.fill(dp, amount + 1);
      dp[0] = 0;
      
      //for loop for each coins, each amount
      for (int j = 0; j < coins.length; j++) {
        for (int i = 0; i <= amount; i++) {
          if (i - coins[j] >= 0)
            dp[i] = Math.min(dp[i], dp[i - coins[j]] + 1);
        }
      }
      
      //return if dp[] is normal value, or just -1
      return dp[amount] > amount ? -1 : dp[amount];
    }
}
View Code

 

 

 

[Follow Up]:

[LC给出的题目变变变]:

 [代码风格] :

 [是否头一次写此类driver funcion的代码] :

 [潜台词] :

 

posted @ 2018-08-09 17:47  苗妙苗  阅读(168)  评论(0编辑  收藏  举报